package io.reisub.openosrs.masterthiever.tasks;

import io.reisub.openosrs.util.Task;
import net.runelite.api.ItemID;
import net.runelite.api.Skill;
import net.runelite.client.plugins.iutils.api.Interactable;
import net.runelite.client.plugins.iutils.game.iNPC;
import net.runelite.client.plugins.iutils.scene.Position;

import java.util.function.Predicate;

public class HandleBank extends Task {
    @Override
    public String getStatus() {
        return "Banking";
    }

    @Override
    public boolean validate() {
        return game.client().getLocalPlayer().getModelHeight() != 1000
                && (game.inventory().full()
                || (!game.inventory().withAction("Eat").exists() && game.modifiedLevel(Skill.HITPOINTS) <= 35));
    }

    @Override
    public void execute() {
        game.tick();
        if (!bank.isOpen()) {
            Interactable bankObj;
            if (calc.random(0, 1) == 0) {
                bankObj = game.objects().filter(obj -> obj.name().equals("Bank booth") && obj.position().equals(new Position(3091, 3245, 0))).first();
            } else {
                bankObj = game.npcs().filter(npc -> npc.name().equals("Banker") && npc.position().equals(new Position(3090, 3245, 0))).first();
            }

            if (bankObj == null) return;

            bankObj.interact("Bank");
            game.waitUntil(() -> bank.isOpen(), 15);
        }

        bank.depositInventory();
        game.tick();

        int quantity = 5 + (game.baseLevel(Skill.HITPOINTS) - game.modifiedLevel(Skill.HITPOINTS)) / 9;

        bank.withdraw(ItemID.SALMON, quantity, false);
        game.waitUntil(() -> game.inventory().withAction("Eat", "Drink").count() > 1, 6);

        bank.close();
        game.waitUntil(() -> !bank.isOpen(), 3);
    }
}
