package io.reisub.openosrs.prayerflick;

import com.google.inject.Provides;
import io.reisub.openosrs.util.Calculations;
import io.reisub.openosrs.util.Util;
import lombok.extern.slf4j.Slf4j;
import net.runelite.api.Client;
import net.runelite.api.GameState;
import net.runelite.api.MenuAction;
import net.runelite.api.events.GameTick;
import net.runelite.api.widgets.Widget;
import net.runelite.api.widgets.WidgetInfo;
import net.runelite.client.callback.ClientThread;
import net.runelite.client.config.ConfigManager;
import net.runelite.client.eventbus.Subscribe;
import net.runelite.client.input.KeyListener;
import net.runelite.client.input.KeyManager;
import net.runelite.client.plugins.Plugin;
import net.runelite.client.plugins.PluginDependency;
import net.runelite.client.plugins.PluginDescriptor;
import net.runelite.client.plugins.iutils.game.Game;
import net.runelite.client.plugins.iutils.game.iWidget;
import net.runelite.client.plugins.iutils.iUtils;
import org.pf4j.Extension;

import javax.inject.Inject;
import java.awt.event.KeyEvent;
import java.util.concurrent.Executors;
import java.util.concurrent.ScheduledExecutorService;
import java.util.concurrent.TimeUnit;

@Extension
@PluginDependency(Util.class)
@PluginDependency(iUtils.class)
@PluginDescriptor(
	name = "Chaos Prayer Flicking",
	description = "",
	enabledByDefault = false
)
@Slf4j
public class Prayerflick extends Plugin implements KeyListener {
	@Inject
	private Game game;

	@Inject
	private Client client;

	@Inject
	private ClientThread clientThread;

	@Inject
	private KeyManager keyManager;

	@Inject
	private Config config;

	@Inject
	private Calculations calc;

	@Provides
	Config provideConfig(ConfigManager configManager) {
		return configManager.getConfig(Config.class);
	}

	private ScheduledExecutorService executor;
	private boolean toggleFlicking;
	private boolean firstFlick;
	private boolean toggledOff;

	@Override
	protected void startUp() {
		log.info("Starting Chaos Prayer Flicking");

		keyManager.registerKeyListener(this);
		executor = Executors.newSingleThreadScheduledExecutor();
	}

	@Override
	protected void shutDown() {
		log.info("Stopping Chaos Prayer Flicking");

		keyManager.unregisterKeyListener(this);
		executor.shutdownNow();
	}

	@Subscribe
	private void onGameTick(GameTick event) {
		if (client == null || client.getGameState() == null || client.getGameState() != GameState.LOGGED_IN || executor == null) return;

		iWidget quickPrayers = game.widget(WidgetInfo.MINIMAP_QUICK_PRAYER_ORB);
		if (quickPrayers == null) return;

		if (toggleFlicking && quickPrayers.actions()!= null) {
			boolean active = quickPrayers.actions().get(0).equals("Deactivate");

			if (!active && !firstFlick) {
				toggle(calc.random(1, 15), quickPrayers);
				return;
			}

			toggle(calc.random(1, 9), quickPrayers);
			toggle(calc.random(90, 100), quickPrayers);

			if (firstFlick) {
				firstFlick = false;
			}
		} else  if (!toggleFlicking && toggledOff && config.deactivateAfterStopping()) {
			toggledOff = false;
			toggle(calc.random(90, 110), quickPrayers);
		}
	}

	private void toggle(int delay, iWidget widget) {
		executor.schedule(() -> {
			widget.interact(0);
		}, delay, TimeUnit.MILLISECONDS);
	}

	@Override
	public void keyTyped(KeyEvent e) {}

	@Override
	public void keyPressed(KeyEvent e) {
		if (config.hotkey().matches(e)) {
			if (toggleFlicking) {
				toggledOff = true;
			} else {
				firstFlick = true;
			}

			toggleFlicking = !toggleFlicking;
		} else if (config.hotkeyMelee().matches(e)) {
			setPrayer(14);
		} else if (config.hotkeyMissiles().matches(e)) {
			setPrayer(13);
		} else if (config.hotkeyMagic().matches(e)) {
			setPrayer(12);
		}
	}

	@Override
	public void keyReleased(KeyEvent e) {}

	private void setPrayer(int childId) {
		executor.schedule(() -> {
			iWidget quickPrayers = game.widget(WidgetInfo.MINIMAP_QUICK_PRAYER_ORB);
			if (quickPrayers == null) return;

			quickPrayers.interact(1);
			game.waitUntil(() -> {
				iWidget w = game.widget(77, 4);
				return w != null && !w.hidden();
			});

			iWidget protection = game.widget(77, 4, childId);
			if (protection == null) return;

			protection.interact(0);

			iWidget update = game.widget(77, 5);
			if (update == null) return;

			update.interact(0);

			if (config.openInventory()) {
				game.openInterface(3);
			}
		}, 0, TimeUnit.MILLISECONDS);
	}
}